using DAL.Models.Entities;
using DAL.Models.Filters;
using DAL.Repositories;
using HRD.LDAPService.JWT;
using HRD.WebApi.Controllers;
using HRD.WebApi.Repositories;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Threading.Tasks;

namespace StaffDBServer.Controllers
{
    [JWTAuthorize]
    public class EmployeeToWebAppController : BaseController<EmployeeToWebApp>
    {
        public EmployeeToWebAppController(IBaseRepository<EmployeeToWebApp> repositoryBase) : base(repositoryBase)
        {
        }

        [HttpPost("EmployeeFilter")]
        public async Task<IActionResult> GetEmployeeToWebAppListAsync([FromBody] EmployeeFilter filter)
        {
            try
            {
                var list = await ((EmployeeToWebAppRepository)EntityRepository).GetListByFilterAsync(filter);
                return new OkObjectResult(list);
            }
            catch (Exception ex)
            {
                this.WriteLogException(ex);
                return StatusCode(StatusCodes.Status400BadRequest, $"Cann't get the filtered list of {typeof(EmployeeToWebApp).Name}");
            }
        }
    }
}